package examples.jce.rsa_aes;

import java.io.*;
import javax.crypto.*;

/**
 * MacInputStream. As it reads in data it passes it though a MAC
 */



public class MacInputStream extends FilterInputStream
{
    private Mac mac = null;

    public MacInputStream(
        InputStream st,
        Mac mac)
    {
        super(st);
        this.mac = mac;
    }

    public int read()
        throws IOException
    {
        int n = in.read();
        if (n >-1)
        {
            mac.update((byte)n);
        }

        return(n);
    }
    
    public int read(
        byte[] b)
        throws IOException
    {
        int n = in.read(b);
        if (n>-1)
        {
            mac.update(b, 0, n);
        }

        return(n);
    }

    public int read(
        byte[]  b,
        int     o,
        int     l)
        throws IOException
    {
        int n = in.read(b, o, l);
        if (n>-1)
        {
            mac.update(b, o, n);
        }

        return(n);
    }
}
